json 使用pre-commit git hook检查PHPCS的PSR-2验证。

Posted

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了json 使用pre-commit git hook检查PHPCS的PSR-2验证。相关的知识,希望对你有一定的参考价值。

#!/usr/bin/env bash

cp contrib/pre-commit.sh .git/hooks/pre-commit
chmod +x .git/hooks/pre-commit
#!/usr/bin/env bash

# Based on code from http://tech.zumba.com/2014/04/14/control-code-quality/

PROJECT=$(php -r "echo dirname(dirname(dirname(realpath('$0'))));")
STAGED_FILES_CMD=$(git diff --cached --name-only --diff-filter=ACMR HEAD | grep \\.php)

RED='\033[0;31m'
YELLOW='\033[0;33m'
GREEN='\033[0;32m'
NC='\033[0m' # No Color

# Determine if a file list is passed
if [ "$#" -eq 1 ]
then
    oIFS=$IFS
    IFS='
    '
    SFILES="$1"
    IFS=$oIFS
fi
SFILES=${SFILES:-$STAGED_FILES_CMD}

printf "${YELLOW}Checking PHP Lint...${NC}\n"
for FILE in $SFILES
do
    php -l -d display_errors=0 $PROJECT/$FILE
    if [ $? != 0 ]
    then
        printf "${RED}Fix the error before commit.${NC}\n"
        exit 1
    fi
    FILES="$FILES $PROJECT/$FILE"
done

if [ "$FILES" != "" ]
then
    printf "${YELLOW}Running Code Sniffer...${NC}\n"

    command -v uuidgen >/dev/null 2>&1 || { printf >&2 "${RED}You require uuidgen but it's not installed. Install with 'apt install uuid-runtime' to correct. Aborting.${NC}\n"; exit 1; }
    TMP_DIR=/tmp/$(uuidgen)
    mkdir -p $TMP_DIR
    for FILE in $SFILES
    do
        mkdir -p $TMP_DIR/$(dirname $FILE)
        git show :$FILE > $TMP_DIR/$FILE
    done
    ./vendor/bin/phpcs --standard=PSR2 --encoding=utf-8 -n -p $TMP_DIR
    PHPCS_ERROR=$?
    rm -rf $TMP_DIR
    if [ $PHPCS_ERROR != 0 ]
    then
        printf "${RED}Fix the error before commit.${NC}\n"
        exit 1
    fi
fi

exit $?
{
    "require-dev": {
        "squizlabs/php_codesniffer": "2.0.*@dev"
    },
    "scripts": {
        "post-install-cmd": [
            "bash contrib/setup.sh"
        ]
    }
}

以上是关于json 使用pre-commit git hook检查PHPCS的PSR-2验证。的主要内容,如果未能解决你的问题,请参考以下文章

Vue+ESLint+Git钩子函数pre-commit配置教程

Git钩子:'.git/hooks/pre-commit':不允许操作

在Git项目中使用pre-commit统一管理hooks

Git: husky > pre-commit (node v14.16.1)

.git/hooks/pre-commit: line 2: ./node_modules/pre-commit/hook: No such file or directory

Git pre-commit钩子修复尾部空白